#include <avr/io.h>
#include <util/delay.h>

// Maximal sind ca. 8 Sekunden mglich
void wait(unsigned char Time_sec)  
{
  unsigned char n;
  n = (Time_sec << 5);      // 5 Bit nach links schieben: n = Time_sec * 32 
  while(n--)                // solange (n <> 0); n-- ist gleichzeitig n=n-1
  {
    //--------------------------------------------------------------------
    // Max. mglicher Delay fr _delay_ms ist: 262.14 ms / F_CPU in MHz
    // Der Parameter fr _delay_ms sollte eine Konstante sein!
    //--------------------------------------------------------------------
    _delay_ms(1000/32);    // Time_sec * 32 * (1000ms / 32) 
  }
}


int main(void)
{
  unsigned char X;         // lokale Variable 
  DDRB=255;             
  while(1)                 // endlos Loop
	{	
    for(X=254; X>0; X=X-1) // for(X=254; X; X--) ist das selbe!
    { 
      PORTB=X;
      wait(1);             // warte eine Sekunde
 	  }
  }
}
